﻿Imports System.Text

Public Class Form1

    ' FrameStyle
    Private m_strFrameStyle As String() = {"STXANDETX(1-1Byte)", "STXANDETX(2-1Byte)", "STXANDETX(1-2Byte)", "STXANDETX(2-2Byte)", "STXANDETX_RTO(1-1Byte)", "STXANDETX_RTO(2-1Byte)", "STXANDETX_RTO(1-2Byte)", "STXANDETX_RTO(2-2Byte)", "STXONLY(1Byte)", "STXONLY_RTO(1Byte)", "STXONLY(2Byte)", "STXONLY_RTO(2Byte)", "ETXONLY(1Byte)", "ETXONLY_RTO(1Byte)", "ETXONLY(2Byte)", "ETXONLY_RTO(2Byte)", "NONEFRAME_READTIMEOUT"}
    ' BaudRate
    Private m_strBaudRate As String() = {"110", "300", "600", "1200", "2400", "4800", "9600", "14400", "19200", "38400", "56000", "57600", "115200"}

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me

        ' FrameSeparationType을 설정하는 SmartComboBox에 아이템을 추가
        cbFrameStyle.DataSource = m_strFrameStyle
        cbFrameStyle.SelectItemIndex = 0

        ' BaudRate를 설정하는 SmartComboBox에 아이템을 추가
        cbBaudRate.DataSource = m_strBaudRate
        cbBaudRate.SelectItemIndex = 6
    End Sub

    ' 송/수신 데이터의 구조가 Frame과 NoneFrame에 따라 FrameSeparationType을 구분하여 설정
    Private Sub btnOpen_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnOpen.Click
        ' 선택한 인덱스를 저장
        Dim iFrameSelect As Integer = cbFrameStyle.SelectItemIndex

        ' smartSerialPort가 Open되지 않은 경우
        If SmartSerialPort1.IsOpen = False Then
            ' STX, ETX를 저장할 바이트 배열
            Dim bSTX As Byte() = New Byte(1) {}
            Dim bETX As Byte() = New Byte(1) {}

            ' SmartSerialPort STX, ETX 초기화
            SmartSerialPort1.STXCodes = Nothing
            SmartSerialPort1.ETXCodes = Nothing

            ' STX, ETX를 변환하여 배열에 저장
            bSTX(0) = Convert.ToByte(labSTX1.Text)
            bSTX(1) = Convert.ToByte(labSTX2.Text)
            bETX(0) = Convert.ToByte(labETX1.Text)
            bETX(1) = Convert.ToByte(labETX2.Text)

            Select Case iFrameSelect
                Case 0, 4
                    ' STX(1Byte), ETX(1Byte)를 사용하는 경우
                    SmartSerialPort1.STXCode = bSTX(0)
                    SmartSerialPort1.ETXCode = bETX(0)
                Case 1, 5
                    ' STX(2Byte), ETX(1Byte)를 사용하는 경우
                    SmartSerialPort1.STXCodes = bSTX
                    SmartSerialPort1.ETXCode = bETX(0)
                Case 2, 6
                    ' STX(1Byte), ETX(2Byte)를 사용하는 경우
                    SmartSerialPort1.STXCode = bSTX(0)
                    SmartSerialPort1.ETXCodes = bETX
                Case 3, 7
                    ' STX(2Byte), ETX(2Byte)를 사용하는 경우
                    SmartSerialPort1.STXCodes = bSTX
                    SmartSerialPort1.ETXCodes = bETX
                Case 8, 9
                    ' STX(1Byte)를 사용하는 경우
                    SmartSerialPort1.STXCode = bSTX(0)
                Case 10, 11
                    ' STX(2Byte)를 사용하는 경우
                    SmartSerialPort1.STXCodes = bSTX
                Case 12, 13
                    ' ETX(1Byte)를 사용하는 경우
                    SmartSerialPort1.ETXCode = bETX(0)
                Case 14, 15
                    ' ETX(2Byte)를 사용하는 경우
                    SmartSerialPort1.ETXCodes = bETX
                Case Else
            End Select

            ' SmartComboBox로 선택한 Item에 따라 Baud_Rate 설정
            SmartSerialPort1.Baud_Rate = CType((Convert.ToInt32(cbBaudRate.Text)), SmartX.SmartSerialPort.BAUDRATE)

            ' Port번호 선택. RS232블럭을 사용하는 경우 IEC667/1000-Series은 COM4 포트만 사용 가능합니다.
            If radCOM1.Checked = True Then
                SmartSerialPort1.PortNo = SmartX.SmartSerialPort.COMPORTNO.COM1
            ElseIf radCOM2.Checked = True Then
                SmartSerialPort1.PortNo = SmartX.SmartSerialPort.COMPORTNO.COM2
            ElseIf radCOM3.Checked = True Then
                SmartSerialPort1.PortNo = SmartX.SmartSerialPort.COMPORTNO.COM3
            ElseIf radCOM4.Checked = True Then
                SmartSerialPort1.PortNo = SmartX.SmartSerialPort.COMPORTNO.COM4
            Else
                SmartSerialPort1.PortNo = SmartX.SmartSerialPort.COMPORTNO.COM7
            End If

            If radCOM4.Checked = False Then
                SmartX.SmartMessageBox.Show("RS232 Block을 사용하는 경우 IEC667/1000은 COM4 포트만 사용할 수 있습니다.")
            End If

            ' Error Check Mode
            If radNone.Checked = True Then
                SmartSerialPort1.ErrorCheckMode = SmartX.SmartSerialPort.ERRORCHECK.NONE
            ElseIf radCheckSum8.Checked = True Then
                SmartSerialPort1.ErrorCheckMode = SmartX.SmartSerialPort.ERRORCHECK.CHECKSUM8
            ElseIf radCheckSum16.Checked = True Then
                SmartSerialPort1.ErrorCheckMode = SmartX.SmartSerialPort.ERRORCHECK.CHECKSUM16
            ElseIf radCRC16.Checked = True Then
                SmartSerialPort1.ErrorCheckMode = SmartX.SmartSerialPort.ERRORCHECK.CRC16
            Else
                SmartSerialPort1.ErrorCheckMode = SmartX.SmartSerialPort.ERRORCHECK.CRC32
            End If

            ' ErrorCodeLocation
            If radHead.Checked = True Then
                SmartSerialPort1.ErrorCode_Location = SmartX.SmartSerialPort.ERRORCODELOCATION.HEADER
            Else
                SmartSerialPort1.ErrorCode_Location = SmartX.SmartSerialPort.ERRORCODELOCATION.TAIL
            End If

            If radEvent.Checked = True Then
                SmartSerialPort1.ReceiveDetect = SmartX.SmartSerialPort.RECEIVEDETECTTYPE.EVENT_QUEUE
            Else
                SmartSerialPort1.ReceiveDetect = SmartX.SmartSerialPort.RECEIVEDETECTTYPE.POLLING_NONEQUEUE
            End If

            ' ReadTimeout 설정 (ReadTimeout을 사용하는 FrameType의 경우 반드시 설정해야 합니다.)
            SmartSerialPort1.ReadTimeout = Convert.ToInt32(udReadTimeOut.Value)
            ' Frame의 BufferSize를 설정
            SmartSerialPort1.FrameBufferSize = Convert.ToUInt32(udBufferSize.Value)
            ' ReceiveFrameDebugMode 설정 (True는 FrameData[STX+Data+ErrorCheckCode+ETX] 송/수신, False는 Data만 송/수신)
            SmartSerialPort1.ReceiveFrameDebugMode = chkDebugMode.Checked
            SmartSerialPort1.RS485SoftwareDetection = False

            ' Port가 열려있지 않다면 Port를 Open합니다.
            If SmartSerialPort1.IsOpen = False Then
                SmartSerialPort1.Open()
                labStatus.Text = "SerialPort Opened"
            End If
        End If
    End Sub

    Private Sub cbFrameStyle_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cbFrameStyle.SelectedIndexChanged
        ' 선택한 인덱스를 저장
        Dim iFrameSelect As Integer = cbFrameStyle.SelectItemIndex

        ' labSTX1, labETX1, labSTX2, labETX2 라벨을 보이도록 설정
        labSTX1.Visible = True
        labETX1.Visible = True
        labSTX2.Visible = True
        labETX2.Visible = True

        ' STX1을 사용하지 않는 경우 
        ' STX Code를 사용하지 않는 경우이며, ETXOnly, NoneFrameReadTimeout에 해당합니다.
        If IsCompare(iFrameSelect, 12, 13, 14, 15, 16) = True Then
            ' STX1 라벨을 안보이도록 설정
            labSTX1.Visible = False
        End If

        ' STX2를 사용하지 않는 경우
        ' STX 2Byte를 사용하지 않는 경우이며, STX 1Byte, ETXOnly, NoneFrameReadTimeout에 해당합니다.
        If IsCompare(iFrameSelect, 0, 2, 4, 6, 8, 9, 12, 13, 14, 15, 16) = True Then
            ' STX2 라벨을 안보이도록 설정
            labSTX2.Visible = False
        End If

        ' ETX1을 사용하지 않는 경우
        ' ETX Code를 사용하지 않는 경우이며, STXOnly, NoneFrameReadTimeout에 해당합니다.
        If IsCompare(iFrameSelect, 8, 9, 10, 11, 16) = True Then
            ' ETX1 라벨을 안보이도록 설정
            labETX1.Visible = False
        End If

        ' ETX2를 사용하지 않는 경우
        ' ETX 2Byte를 사용하지 않는 경우이며, STXOnly, ETX1Byte, NoneFrameReadTimeout에 해당합니다.
        If IsCompare(iFrameSelect, 0, 1, 4, 5, 8, 9, 10, 11, 12, 13, 16) = True Then
            ' ETX2 라벨을 안보이도록 설정
            labETX2.Visible = False
        End If

        ' 선택한 Frame에 맞춰서 FRAMESEPARATIONTYPES를 설정합니다.
        Select Case iFrameSelect
            Case 0, 1, 2, 3
                ' STXANDETX
                SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.STXANDETX
            Case 4, 5, 6, 7
                ' STXANDETX_READTIMEOUT
                SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.STXANDETX_READTIMEOUT
            Case 8, 10
                ' STXONLY
                SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.STXONLY
            Case 9, 11
                ' STXONLY_READTIMEOUT
                SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.STXONLY_READTIMEOUT
            Case 12, 14
                ' ETXONLY_READTIMEOUT
                SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.ETXONLY
            Case 13, 15
                ' STXONLY_READTIMEOUT(2Byte)
                SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.ETXONLY_READTIMEOUT
            Case 16
                ' NONEFRAME_READTIMEOUT
                SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.NONEFRAME_READTIMEOUT
            Case Else
        End Select
    End Sub

    ' Data 전송
    Private Sub btnSend_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSend.Click
        SendData()

        SmartTimer1.Start()
    End Sub

    ' Repeat CheckBox가 체크되어 있는 경우 연속 송신
    Private Sub smartTimer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer1.Tick
        If chkRepeat.Checked = False Then
            SmartTimer1.[Stop]()
            Return
        End If

        SendData()
    End Sub

    ' iRefValue값과 iArgs값을 비교하는 함수
    Private Function IsCompare(ByVal iRefValue As Integer, ByVal ParamArray iArgs As Integer()) As Boolean
        ' 값을 비교하여 일치하는 값이 있다면 True 없다면 False
        Return iArgs.Contains(iRefValue)
    End Function

    ' Data를 Send하기 위한 함수
    Private Sub SendData()
        ' Frame Style에 따른 Send Method 분류
        ' 1. Frame-Event / 2. Frame-Polling
        If SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.NONEFRAME_READTIMEOUT Then

            If radSendAscii.Checked = True Then
                SmartSerialPort1.WriteNoneFrame(labSendData.Text, SmartX.SmartSerialPort.CODETYPES.ASCIICODE)
            ElseIf radSendUnicode.Checked = True Then
                SmartSerialPort1.WriteNoneFrame(labSendData.Text, SmartX.SmartSerialPort.CODETYPES.UNICODE)
            Else
                Dim bByteArray As Byte() = Encoding.UTF8.GetBytes(labSendData.Text)
                SmartSerialPort1.WriteNoneFrame(bByteArray)
            End If
        Else

            If radSendAscii.Checked = True Then
                SmartSerialPort1.WriteFrame(labSendData.Text, SmartX.SmartSerialPort.CODETYPES.ASCIICODE)
            ElseIf radSendUnicode.Checked = True Then
                SmartSerialPort1.WriteFrame(labSendData.Text, SmartX.SmartSerialPort.CODETYPES.UNICODE)
            Else
                ' 문자열 --> Byte[] 변환후 전송
                Dim bByteArray As Byte() = Encoding.UTF8.GetBytes(labSendData.Text)
                SmartSerialPort1.WriteFrame(bByteArray)
            End If
        End If
    End Sub

    ' Event 수신 방식
    Private Sub smartSerialPort1_OnReadQueueEvent() Handles SmartSerialPort1.OnReadQueueEvent
        Dim strData As String = ""
        Dim readByte As Byte()
        Dim eStatus As SmartX.SmartSerialPort.FRAMEDATAREADSTATUS

        ' 1. Frmae, 2. NoneFrame
        eStatus = SmartSerialPort1.ReadQueue(readByte)

        ' ASCII, UniCode, Binary 방식에 따라 구분
        If radRecvAscii.Checked = True Then
            strData = SmartX.SmartSerialPort.ConvertAsciiByteToString(readByte)
        ElseIf radRecvUnicode.Checked = True Then
            strData = SmartX.SmartSerialPort.ConvertUnicodeByteToString(readByte)
        Else
            ' 수신된 프레임 데이터를 각각의 바이트를 16진수로 표시 합니다
            For i As Integer = 0 To readByte.Length - 1
                strData += String.Format(" {0:X2}", readByte(i))
            Next
        End If

        ' ListBox에 데이터 삽입
        If eStatus = SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY Then
            lstRecvData.AddItem("EMPTY")
        ElseIf eStatus = SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.FAILDATA Then
            lstRecvData.AddItem("Fail")
        Else
            lstRecvData.AddItem(strData)
        End If
    End Sub

    Private Sub btnRecvPolling_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnRecvPolling.Click
        Dim strData As String = Nothing
        Dim readByte As Byte() = New Byte(9) {}
        Dim eStatus As SmartX.SmartSerialPort.FRAMEDATAREADSTATUS = SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY

        If SmartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.NONEFRAME_READTIMEOUT Then
            ' 1. NoneFrame
            eStatus = SmartSerialPort1.ReadNoneFrame(readByte, 1000)
        Else
            ' 2. Frame
            eStatus = SmartSerialPort1.ReadFrame(readByte)
        End If

        ' ListBox에 데이터 삽입
        If eStatus = SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY Then
            lstRecvData.AddItem("EMPTY")
        ElseIf eStatus = SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.FAILDATA Then
            lstRecvData.AddItem("Fail")
        Else
            ' ASCII, UniCode, Binary방식에따라 구분
            If radRecvAscii.Checked = True Then
                strData = SmartX.SmartSerialPort.ConvertAsciiByteToString(readByte)
            ElseIf radRecvUnicode.Checked = True Then
                strData = SmartX.SmartSerialPort.ConvertUnicodeByteToString(readByte)
            Else
                ' 수신된 프레임 데이터를 각각의 바이트를 16진수로 표시 합니다
                For i As Integer = 0 To readByte.Length - 1
                    strData += String.Format(" {0:X2}", readByte(i))
                Next
            End If

            lstRecvData.AddItem(strData)
        End If
    End Sub

    Private Sub btnClose_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClose.Click
        If SmartSerialPort1.IsOpen = True Then
            SmartSerialPort1.Close()
            labStatus.Text = "SerialPort Closed"
        End If
    End Sub

    Private Sub btnListClear_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnListClear.Click
        lstRecvData.ClearAll()
    End Sub

    Private Sub RadioButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles radPolling.Click, radEvent.Click
        If radEvent.Checked = True Then
            btnRecvPolling.Visible = False
        Else
            btnRecvPolling.Visible = True
        End If
    End Sub
End Class
